#import urllib2,re,htmlentitydefs
#from datetime import timedelta,datetime
#from HTMLParser import HTMLParser
#from lxml import etree
#from StringIO import StringIO


# make sure to replace artwork with what you want
# these filenames reference the example files in
# the Contents/Resources/ folder in the bundle
ART	 = 'raitv_art.jpg'
ICON = 'raitv_icon.png'

RAITV = 'http://www.rai.tv'
PROGRAMSPAGE = RAITV+'/dl/RaiTV/cerca_programmi.html?'
NEWSPAGE = 'http://www.rai.it/dl/rai/news.html?refresh_ce'
TG2PAGE = 'http://www.tg2.rai.it/dl/tg2/multimedia.html'
VIDEOPAGE = RAITV + '/dl/RaiTV/programmi/media/'
LISTE = RAITV + '/dl/RaiTV/programmi/liste/'

DURATION_FORMAT = '%H:%M:%S'
DURATION_ZERO = '00:00:00'

VIDEO_PREFIX = "/video/raitv"

TITLE = 'Rai.tv'

def toMilliseconds(s):
	hours, minutes, seconds = (["0", "0"] + s.split(":"))[-3:]
	hours = int(hours)
	minutes = int(minutes)
	seconds = float(seconds)
	return int(3600000 * hours + 60000 * minutes + 1000 * seconds)

####################################################################################################
#
# Example main menu referenced in the Start() method
# for the 'Video' prefix handler
#

def Start():
	#Plugin.AddPrefixHandler(VIDEO_PREFIX, MainMenu, NAME, ICON, ART)
	Plugin.AddViewGroup("InfoList", viewMode="InfoList", mediaType="items")
	Plugin.AddViewGroup("List", viewMode="List", mediaType="items")
	
	ObjectContainer.title1 = TITLE
	ObjectContainer.art = R(ART)
	ObjectContainer.view_group = 'List'
	
	DirectoryObject.thumb = R(ICON)
	VideoClipObject.thumb = R(ICON)
	
	HTTP.CacheTime = CACHE_1HOUR

@handler(VIDEO_PREFIX, TITLE,thumb=ICON,art=ART)
def MainMenu():
	oc = ObjectContainer()
	oc.add(DirectoryObject(key = Callback(OnDemandMenuAZ), title = 'Programmi On Demand',thumb=R('raitv_icon_archivio.png')))
	oc.add(DirectoryObject(key = Callback(NewsMenu), title = 'Telegiornali',thumb=R('raitv_icon_news.png')))
	#oc.add(DirectoryObject(key = Callback(LiveMenu), title = 'Dirette',thumb=R('raitv_icon_live.png')))
	return oc

def OnDemandMenuAZ():
	oc = ObjectContainer(title2 = 'Lista programmi A-Z', art = R('raitv_art_archivio.jpg'))
	# Now we need to add the list of letters!
	oc.add(DirectoryObject(key = Callback(ListPrograms, letter= '0'),title = '0-9'))
	for i in range(26):
		name = chr(ord('A')+i)
		oc.add(DirectoryObject(key = Callback(ListPrograms,letter = name),title = name))
	return oc
	
def NewsMenu():
	#oc = ObjectContainer(title2 = title, art = R('raitv_art_news.jpg')
	#return oc
	news = ObjectContainer()
	news.add(DirectoryObject(key = Callback(Tg1), title = 'Tg1',thumb=R('raitv_icon_news.png')))
	news.add(DirectoryObject(key = Callback(Tg2), title = 'Tg2',thumb=R('raitv_icon_news.png')))
	news.add(DirectoryObject(key = Callback(Tg3), title = 'Tg3',thumb=R('raitv_icon_news.png')))
	return news


def Tg1():
	# TG1
	newsTG1 = ObjectContainer()
	page = HTML.ElementFromURL(NEWSPAGE)
	for tg in page.xpath("//body//div[@class='colSx']//div[@class='box']"):
		channel = tg.xpath(".//div[@class='top']//h3")[0].text
		if "Tg1" in channel:
			temp = tg.xpath(".//div[@class='mid']//div[@class='newsTg']//ul[@class='ediz']//li")
			for ediz in temp:
				redirecturl = ediz.xpath(".//@href")[0]
				Log.Info("Redirect: "+redirecturl)
				redirectpage = HTML.ElementFromURL(redirecturl)
				video = redirectpage.xpath("//body//div//div//div[@class='infoServizi']//div//h2")[0]
				title = video.xpath(".//a")[0].text
				url = VIDEOPAGE + video.xpath(".//@id")[0]+".html"
				#<body class="popEdizioni"> <div class="popUp"> <div class="Edizione"> <div class="Player">  </div> <div class="infoServizi"> <div class="top"> <h2 id="ContentItem-4bd80082-535b-41a7-812e-a8a6b6c26dbe"> <a href="#">TG1 ore 8:00 del 10 febbraio 2013</a> </h2> </div> <div class="mid"> <div class="holder popServizi-bar" id="Servizi"> <div id="pane_popServizi" class="scroll-pane"> <ul class="servizi"><script type="text/javascript"> 		
				newsTG1.add(VideoClipObject(title = title,url = url))
	if len(newsTG1) == 0:
		return MessageContainer("No items available","There are no items available")
	else:
		return newsTG1
	#return MessageContainer("Not available","To be implemented")

def Tg2():
	newsTg2 = ObjectContainer()
	# TG2
	page = HTML.ElementFromURL(TG2PAGE)
	path = page.xpath("//body//div[@class='boxServizi']//div[@class='tab']//ul")[0]
	for video in path.xpath("//li//a[@class='integrale']"):
		Log.Info(video.xpath(".//@data-ediz"))
		Log.Info(video.xpath(".//@data-url"))
		Log.Info(video.xpath(".//@data-uniq"))
		title = "Tg2 - " + video.xpath(".//@data-ediz")[0]
		url = VIDEOPAGE + video.xpath(".//@data-uniq")[0] + "-tg2.html"
		Log.Info(url)
		newsTg2.add(VideoClipObject(title = title,url = url))
	if len(newsTg2) == 0:
		return MessageContainer("No items available","There are no items available")
	else:
		return newsTg2
	#return MessageContainer("Not available","To be implemented")
		
def Tg3():
	# TG3
	newsTg3 = ObjectContainer()
	page = HTML.ElementFromURL(NEWSPAGE)
	for tg in page.xpath("//body//div[@class='colSx']//div[@class='box']"):
		channel = tg.xpath(".//div[@class='top']//h3")[0].text
		if "Tg3" in channel:
			temp = tg.xpath(".//div[@class='mid']//div[@class='newsTg']//ul[@class='ediz']//li")
			for ediz in temp:
				title = channel + ' - ' + ediz.xpath(".//a")[0].text
				url = ediz.xpath(".//@href")[0]
				newsTg3.add(VideoClipObject(title = title,url = url))
	if len(newsTg3) == 0:
		return MessageContainer("No items available","There are no items available")
	else:
		return newsTg3
	#return MessageContainer("Not available","To be implemented")
	
def LiveMenu():
	#oc = ObjectContainer(title2 = title, art = R('raitv_art_live.jpg')
	#return oc
	return MessageContainer("Not available","To be implemented")

def ListPrograms(letter):
	"""
	Scan programs and create a list
	"""
	programs = ObjectContainer()
	
	page = HTML.ElementFromURL(PROGRAMSPAGE+letter)
	for p in page.xpath("//body//ul[@class='elencoRicerca']//li"):
		# check if podcast! FIXME!
		title= p.xpath(".//div[@class='internal']/text()")[0]
		url1,sep,id = p.xpath(".//a/@href")[0].rpartition('/')
		url = RAITV+url1+sep+'page'+sep+id
		summary = "Program summary"
		thumb = R(ICON)
		programs.add(DirectoryObject(key = Callback(ListSeasons, url = url), title= title, thumb=thumb, summary = summary)) #FIXME!
	
	if len(programs) == 0:
		return MessageContainer(
			"No items available",
			"There are no items available"
			)
	else:
		return programs

def ListSeasons(url):
	# Puntate!!!!
	# Edizioni!
	print "PROGRAM PAGE: ", url
	page = HTML.ElementFromURL(url)
	
	# Depending on the seasons
	videos = page.xpath("//li[@class='Video ']")
	if len(videos) > 1:
		seasons = ObjectContainer(title2 = 'Categorie')
		for v in videos:
			url = v.xpath("./a/@id")[0]
			title = v.xpath("./a/text()")[0]
			summary = "Program summary"
			thumb = R(ICON)
			seasons.add(DirectoryObject(key = Callback(ListEpisodes, url = LISTE+url+'-V-0.html'), title= title, thumb=thumb, summary = summary))
		return seasons
	else:
		return ListEpisodes(LISTE+videos[0].xpath("./a/@id")[0]+'-V-0.html')
	
def ListEpisodes(url):
	# This gets us the first page in any case
	#print url
	page = HTML.ElementFromURL(url)
	
	videos = page.xpath("//div[@class='listaVideo iconeStrette']//ul//li[@class='']")
	# First check if paginazione exists!
	prev = page.xpath("//div[@class='listaVideo iconeStrette']//div[@class='Paginazione']//ul//li[@class='prec' and @style='visibility: hidden;']")
	next = page.xpath("//div[@class='listaVideo iconeStrette']//div[@class='Paginazione']//ul//li[@class='succ'and @style='visibility: hidden;']")
		# Check if we have more pages
	try:
		if prev==[]:
			prev = True
		else:
			prev = False
		if next==[]:
			next = True
			following = page.xpath("//div[@class='listaVideo iconeStrette']//div[@class='Paginazione']//ul//li[@id='selected']//following-sibling::li")[0]
			#print len(following)
			id = following.xpath(".//a//@id")[0]
			nexturl = LISTE+id+'.html'
		else:
			next = False
	except:
		next = False
		prev = False
	# Create a menu with the episodes. If there is a "succ", add a "More" link
	episodes = ObjectContainer(title2='Episodi')
	
	for v in videos:
	
		url = VIDEOPAGE + v.xpath(".//@id")[0] + ".html"
		#img= v.xpath(".//img/@src")[0]
		#title= v.xpath(".//a/h2/text()")[0]
		duration= v.xpath(".//ul/li[@class='specDurata']/text()")[1]
		#date = v.xpath(".//ul/li[@class='specPubblicato']/text()")[1]
		
		# Better to get the metadata from the url!!! The Service will only manage the actual media link ...
		# Question: can we delay that thing?
		page1 = HTML.ElementFromURL(url)
		type = page1.xpath("//head//meta[@name='tipo']//@content")[0]
		if type == "Video":
			title = page1.xpath("//head//meta[@name='title']//@content")[0]
			summary = page1.xpath("//head//meta[@name='description']//@content")[0]
			thumb = RAITV + page1.xpath("//head//link[@rel='image_src']//@href")[0]
			date = page1.xpath("//head//meta[@name='itemDate']//@content")[0]
			episodes.add(VideoClipObject(url = url,title = title,thumb = thumb, summary = summary, duration = toMilliseconds(duration), originally_available_at = Datetime.ParseDate(date)))
	if next:
		episodes.add(DirectoryObject(key = Callback(ListEpisodes, url = nexturl), title= 'More...'))	
	if len(episodes)>0:
		return episodes
	else:
		return MessageContainer("No videos available","There are no videos available")

# Part of the "search" example 
# query will contain the string that the user entered
# see also:
#	http://dev.plexapp.com/docs/Objects.html#InputDirectoryItem
# def SearchResults(sender,query=None):
#	return MessageContainer(
#		"Not implemented",
#		"In real life, you would probably perform some search using python\nand then build a MediaContainer with items\nfor the results"
#	)

# http://www.rai.tv/dl/RaiTV/programmi/info/PublishingBlock-f7fdf709-2996-470e-9286-b77ef6aa43f0.html
  
# <param value="videoPath=http://mediapolis.rai.it/relinker/relinkerServlet.htm?cont=oUrSAlsE8iEeeqqEEqual,pathbanner=http://ad2.neodatagroup.com/ad/load_ndgruler.jsp?sid=49&amp;loc=rtv_streaming_cultura^rtv_streaming_passepartout^wmv^&amp;bt=n&amp;wt=n&amp;jsvar=&amp;rnd=1214127945127,aspect=43,auto=true" name="initparams"/>
# INFO PROGRAMMA print ReadWebPage('http://www.rai.tv/dl/RaiTV/browse.html?page.id=Page-e741239f-829c-4ac1-b496-029d3033429e')